#!/usr/bin/perl

$n=0;
$datafile=shift(@ARGV);
$phone=shift(@ARGV);

@real=(0,0,0,0,0,0,0,0,1,1);
@attrnames=("base-1","base+1","sylpos-1","sylpos","sylpos+1",
	    "word-1","word","word+1","leftphones","rightphones",
	    "cmanner-1","cplace-1","vmanner-1","vplace-1",
	    "cmanner+1","cplace+1","vmanner+1","vplace+1",
	    "realization");

for ($i=0;$i<19;$i++) {
    $attr[$i]={};
    $finalattr[$i]={};
}

open(DATA,$datafile) || die("Can't open $datafile for reading");
while(<DATA>) {
    chop;
    if (/^#/) {
	push(@phdata,[$_]);
	next;
    }
    @data=split;
    ($ph)=splice(@data,1,1);
    if ($ph eq $phone) {
	push(@phdata,[@data]);
	for($i=0;$i<19;$i++) {
	    $attr[$i]->{$data[$i]}++;
	}
    }
}
close(DATA);

for ($i=0;$i<19;$i++) {
    next if ($real[$i]);
    foreach $x (keys %{$attr[$i]}) {
	if ($attr[$i]->{$x}<$n) {
	    $finalattr[$i]->{"UNK"}+=$attr[$i]->{$x};
	} else {
	    $finalattr[$i]->{$x}+=$attr[$i]->{$x};
	}
    }
    $finalattr[$i]->{"UNK"}+=0;
}

print "\@relation $phone\n\n";
for($i=0;$i<19;$i++) {
    print "\@attribute $attrnames[$i]";
    if ($real[$i]) {
	print " real\n";
    } else {
	print " {";
	$comma="";
	foreach $x (sort keys %{$finalattr[$i]}) {
	    print "$comma$x";
	    $comma=",";
	}
	print "}\n";
    }
}
print "\n\@data\n";
foreach $d (@phdata) {
    @x=@{$d};
    if ($x[0] =~ /^#/) {
	print $x[0],"\n";
	next;
    }

    print join(",",@x),"\n";

    for($i=0;$i<19;$i++) {
	next if ($real[$i]);
	if (!defined($finalattr[$i]->{$x[$i]})) {
	    $x[$i]="UNK";
	}
    }

    print join(",",@x),"\n";
}

	


 
